#!/usr/bin/python
#-*- coding:utf-8 -*-
#**********************************************************
#  周波数アナライザ　Pythonマクロ関数群
#　パラメータのファイル保存とシャットダウン実行
#**********************************************************
import webiopi
import subprocess as proc
import serial

#ディレクトリとファイル名宣言
path = '/home/pi/Analyzer/'
filename1 = 'Freq.txt'
filename2 = 'Endflag.txt'

#******** 計測開始関数起動　************
@webiopi.macro
def StartUp(para):
	try:
		f = open(path+filename1, 'w')
		f.write(para)
		f.close()
		f = open(path+filename2, 'w')
		f.write('0')
		f.close()
		proc.call("sudo killall sudo", shell=True)
		proc.call("sudo python /home/pi/Analyzer/Mesure.py &", shell=True)

	except keyboardInterrupt:
		pass
#********* 計測停止 ***********
@webiopi.macro
def StopAP():
	try:
		f = open(path+filename2, 'w')
		f.write('1')
		f.close

	except keyboardInterrupt:
		pass

#***** シャットダウン実行関数 *******
@webiopi.macro
def ShutCmd():
	proc.call("sudo killall sudo", shell=True)
	proc.call("sudo /sbin/shutdown -h now", shell=True)	
