/********************************************************************
*  gUjbg
*  Raspberry Pi 3BɐڑĎg
*  góFAD9834@SPIڑ 67.108863MHz 1/4HzPʂŐݒ\
*  dsPIC33EP64GS502gp@D/Aɂ钼o͂ǉ
********************************************************************/
#include <xc.h>
#include <math.h>
#include <stdlib.h>
/* RtBM[V̐ݒ */
// FSEC
#pragma config BWRP = OFF               // Boot Segment Write-Protect bit (Boot Segment may be written)
#pragma config BSS = DISABLED           // Boot Segment Code-Protect Level bits (No Protection (other than BWRP))
#pragma config BSEN = OFF               // Boot Segment Control bit (No Boot Segment)
#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
#pragma config GSS = DISABLED           // General Segment Code-Protect Level bits (No Protection (other than GWRP))
#pragma config CWRP = OFF               // Configuration Segment Write-Protect bit (Configuration Segment may be written)
#pragma config CSS = DISABLED           // Configuration Segment Code-Protect Level bits (No Protection (other than CWRP))
#pragma config AIVTDIS = OFF            // Alternate Interrupt Vector Table bit (Disabled AIVT)
// FBSLIM
#pragma config BSLIM = 0x1FFF           // Boot Segment Flash Page Address Limit bits (Boot Segment Flash page address  limit)
// FSIGN
// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Source Selection (Fast RC Oscillator with divide-by-N with PLL module (FRCPLL) )
#pragma config IESO = OFF               // Two-speed Oscillator Start-up Enable bit (Start up with user-selected oscillator source)
// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
#pragma config OSCIOFNC = ON            // OSC2 Pin Function bit (OSC2 is general purpose digital I/O pin)
#pragma config IOL1WAY = OFF            // Peripheral pin select configuration bit (Allow multiple reconfigurations)
#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)
#pragma config PLLKEN = ON              // PLL Lock Enable Bit (Clock switch to PLL source will wait until the PLL lock signal is valid)
// FWDT
#pragma config WDTPOST = PS32768        // Watchdog Timer Postscaler bits (1:32,768)
#pragma config WDTPRE = PR128           // Watchdog Timer Prescaler bit (1:128)
#pragma config WDTEN = OFF              // Watchdog Timer Enable bits (WDT and SWDTEN disabled)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
#pragma config WDTWIN = WIN25           // Watchdog Timer Window Select bits (WDT Window is 25% of WDT period)
// FPOR
// FICD
#pragma config ICS = PGD1               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)
#pragma config BTSWP = OFF              // BOOTSWP Instruction Enable/Disable bit (BOOTSWP instruction is disabled)
// FDEVOPT
#pragma config PWMLOCK = OFF            // PWMx Lock Enable bit (PWM registers may be written without key sequence)
#pragma config ALTI2C1 = OFF            // Alternate I2C1 Pin bit (I2C1 mapped to SDA1/SCL1 pins)
#pragma config ALTI2C2 = OFF            // Alternate I2C2 Pin bit (I2C2 mapped to SDA2/SCL2 pins)
#pragma config DBCC = OFF               // DACx Output Cross Connection bit (No Cross Connection between DAC outputs)
// FALTREG
#pragma config CTXT1 = OFF              // Specifies Interrupt Priority Level (IPL) Associated to Alternate Working Register 1 bits (Not Assigned)
#pragma config CTXT2 = OFF              // Specifies Interrupt Priority Level (IPL) Associated to Alternate Working Register 2 bits (Not Assigned)
// FBTSEQ
#pragma config BSEQ = 0xFFF             // Relative value defining which partition will be active after device Reset; the partition containing a lower boot number will be active (Boot Sequence Number bits)
#pragma config IBSEQ = 0xFFF            // The one's complement of BSEQ; must be calculated by the user and written during device programming. (Inverse Boot Sequence Number bits)
/***** DDSpsw ******/
#define ddsFSYN     LATBbits.LATB11
#define ddsSCLK     LATBbits.LATB12
#define ddsSDAT     LATBbits.LATB13
#define RedLED      LATAbits.LATA2
#define GreenLED    LATBbits.LATB0
/**** ϐ`@***/
#define  Fcy  60000000
unsigned long temp, Freq, sFreq, eFreq, StepFreq, tSetup, Interval;
unsigned char State, Flag, SweepFlag, Step;
char RcvBuf[32];                   // UARTMobt@
char SndBuf[32];                   // UARTMobt@
unsigned int Index, i, j, SetDC;
double  SetPoint;
/** ֐vg^CsO */
void Process(void);
void Send(unsigned char data);
void SendStr(unsigned char *buf);
void SetupDDS( unsigned long freqdata, unsigned char kind);
void SerialOut(unsigned long data);


/************ C֐ ********************/
int main(void){
    /* NbNgݒ */
    CLKDIVbits.PLLPRE = 0;          // 7.37MHz/2=3.685
    PLLFBDbits.PLLDIV = 63;         // 7.37/2*65=240MHz
    CLKDIVbits.PLLPOST = 0;         // 240/2=120MHz -> 60MIPS 
    /* o̓s[hݒ */
    LATB = 0xFE;                    // FSYNC,SCLK High
    TRISA = 0x13;                   // 
    TRISB = 0x00CC;                 // 
    ANSELA = 0;                     // ׂăfW^
    ANSELB = 0x0008;                // RB3̂݃AiO
    /* Timer2+Timer3 ݒ */
    T2CON = 0x0018;                 // 1/8 32bit Timer
    PR2 =  0;                       // 50msec
    PR3 = 0x0100;
    IFS0bits.T3IF = 0;
    IEC0bits.T3IE = 1;              // 荞݋
    /* UART1ݒ@115kbps  */
    RPOR2bits.RP36R = 0x01;         // UiTX to RP36(RB4))
    RPINR18bits.U1RXR = 34;         // U1RX to RP34(RB2))
    U1MODE = 0x8808;                // UART1ݒ BRGH=1
    U1STA =  0x0400;                // UART1ݒ
    U1BRG = 129;                     // 115kbps@60MHz
    IPC2bits.U1RXIP = 2;            // UART1荞݃x
    IFS0bits.U1RXIF = 0;            // 荞݃tONA 
    /* 12bit D/ARo[^ݒ */
    CMP1CONbits.EXTREF = 0;         // Select Internal Ref
    CMP1CONbits.RANGE = 1;          // Max is AVDD
    CMP1CONbits.DACOE = 1;          // D/A Output Enable
    CMP1DACbits.CMREF = 0;          // 0%
    CMP1CONbits.CMPON = 1;          // CMP1 Enable
    /* DDS@AD9834̏l */
    Freq = 1000;                    // l1kHz
    /* ϐ */
    Index = 0;
    Flag = 0;
    State = 1;
    IEC0bits.U1RXIE = 1;            // UART1M荞݋
    SetupDDS(Freq, '1');            // gݒo͎s
    GreenLED = 1;
    /*********** C[v ***************/
    while(1)  {
        /* MR}h[v */
        if((Flag == 1) && (RcvBuf[0] == 'S')) {
            RedLED ^= 1;            // ڈLED]
            Process();              // R}hs
            Index = 0;              // obt@|C^
            Flag = 0;               // MtONA
        }
    }
}
/**************************************************
*  f[^M֐
*  f[^RcvBuf[] 
 * SNffffffffwddddE @ @Œg̏ꍇ
 * SWsssssssseeeeeeeezttttE  XC[v̏ꍇ
***************************************************/
void Process(void){ 
    char freqstr[9],  dclvl[5];
    /******** MR}hƂ̏ ********/
    switch(RcvBuf[1]){                          // R}hR[h`FbN
        /* Œgo͂̏ꍇ SNffffffffwddddE*/
        case 'N':
            /* gݒ萧 */
            for(i=0; i<8; i++){                 // go
                freqstr[i] = RcvBuf[i+2];
            }
            freqstr[8] = 0;                     // I}[N
            Freq = atol(freqstr);               // lɕϊ
            SetupDDS(Freq, RcvBuf[10]);         // gݒo͎s
            /* do͂̐ݒ萧@*/
            for(i=0; i<4; i++){                 // dlo
                dclvl[i] = RcvBuf[i+11];
            }
            dclvl[4] = 0;                       // I}[N
            SetDC = atoi(dclvl);                // dݒlɕϊ
            if(SetDC > 4095)                    // `FbN
                SetDC = 4095;                   // Upper Limit
            CMP1DACbits.CMREF = SetDC;          // ݒ萧
            break;
        /* XC[v̏ꍇ SWsssssssseeeeeeeezttttE*/
        case 'W':
            if(SweepFlag == 1){                 // XC[vs̏ꍇ
                SweepFlag = 0;                  // tO
                T2CONbits.TON = 0;              // Timer2 ~@XC[v~
            }
            /* g擾 */
            for(i=0; i<8; i++){                 // Jngo
                freqstr[i] = RcvBuf[i+2];
            }            
            freqstr[8] = 0;                     // I}[N
            sFreq = atol(freqstr);              // lɕϊ
            for(i=0; i<8; i++){                 // Igo
                freqstr[i] = RcvBuf[i+10];
            }            
            freqstr[8] = 0;                     // I}[N
            eFreq = atol(freqstr);              // lɕϊ
            Step = RcvBuf[18];                  // gԊu@01
            for(i=0; i<4; i++){                 // ԊԊuo
                freqstr[i] = RcvBuf[i+19];
            }            
            freqstr[4] = 0;                     // I}[N 
            Interval = atol(freqstr);           // ԊԊuɕϊ
            if(Interval < 10)                   // ԏ㉺`FbN
                Interval = 10;                  // 10msecȏ
            if(Interval > 1000)
                Interval = 1000;                // 1bȉ
            tSetup = (Fcy/8000)*Interval;       // ^C}ݒ
            PR2 = tSetup;
            PR3 = tSetup >> 16;
            T2CONbits.TON = 1;                  // Start Timer2+Timer3
            break;
        /* ̑ */
        default:
            break;
    }     
}
/************************************************
*  UARTM荞ݏ֐
 *  SNfffftddE 
 *      ffffffff:o͎g@Max20MHz
 *      t   :0=gA1=`g+gA2=Opg
 *      dddd :DCxl(Max 4095)
************************************************/
void __attribute__((interrupt, no_auto_psv))  _U1RXInterrupt(void){
    char  data;

    /* MG[`FbN */
    IFS0bits.U1RXIF = 0;                    // 荞݃tONA
    if(U1STAbits.OERR || U1STAbits.FERR) {
        data = U1RXREG;;
        U1STA &= 0xFFF0;                    // G[tONA
        U1MODE = 0;                         // UART1~
        U1MODE = 0x8808;                    // UART1L
        U1STA =  0x0400;                    // TX Enable        
        Index = 0;
    }
    else {                                  // M̏ꍇ
        if(Index < 30){                     // 30oCgȉ̏ꍇ
            data = U1RXREG;                 // f[^o
            RcvBuf[Index++] = data;         // f[^i[
            if(data == 'E'){                // I
                Flag = 1;                   // MtOI
                Index = 0;                  // |C^Zbg
            }
        }
        else                                // obt@I[o[̏ꍇ
            data = U1RXREG;                 // ǂݔ΂Ė
    }
}
/********************************
 * UART MsTu֐
 ********************************/
void Send(unsigned char Data){
    while(!U1STAbits.TRMT);             // MfB[҂
    U1TXREG = Data;                     // Ms
}
/*********************************
 * UARTobt@M
 *********************************/
void SendStr(unsigned char *buf){
    while(*buf != 0)
        Send(*buf);
}
/**************************************
 * ^C}3荞ݏ֐
 *@gXC[v̎s
 **************************************/
void __attribute__((interrupt, no_auto_psv))  _T3Interrupt(void){
    if(Step == '1'){                // 1/100Xebv̏ꍇ
        StepFreq = (long)pow(10, ((int)(log10(sFreq))-2));
        sFreq += StepFreq;          // Z
    }
    else{                           // 1/10̏ꍇ
        StepFreq = (long)pow(10, ((int)(log10(sFreq))-1));
        sFreq += StepFreq;          // Z
    }
    if(sFreq > eFreq){              // I
        SweepFlag = 0;              // XC[vtOZbg
        T2CONbits.TON = 0;          // ^C}~
    }
    else{                           // p̏ꍇ
        SetupDDS(sFreq, '0');       // gݒo͎s        
    }
    IFS0bits.T3IF = 0;              // 荞݃tONA
}
/********************************
 *  Setup DDS AD9834
 *  NbN 2^26@ݒ  2^28
 **********************************/
void SetupDDS( unsigned long freqdata, unsigned char kind){
    unsigned long temp;
    unsigned int uptemp, lowtemp;
    
    /* 1/4HzPʂȂ̂Ŏgx4ݒl  */
    /* 14rbg2P^ɂďo    */
    temp = 4 * freqdata;                            // 1/4HzP
    lowtemp = (unsigned int)(temp & 0x3FFF);        // 14rbg
    uptemp = (unsigned int)((temp >> 14) & 0x3FFF); // 14rbg
    /* go͂̂=0x2008  Opgo͂̂= 0x200A */
    /* g{`go=0x2028@*/
    switch(kind){
        case '0':
            SerialOut(0x2008);          // ĝݏo
            break;
        case '1':
            SerialOut(0x2028);          // g`go
            break;
        case '2':
            SerialOut(0x200A);          // Opĝݏo
            break;
        default:
            break;
    }
    /* gݒ */
    SerialOut(lowtemp + 0x4000);        // 14rbgo
    SerialOut(uptemp + 0x4000);         // 14rbgo
}
/*********************************
 *  DDS@AD9834M֐
 * @16rbgVAőM
 *********************************/
void SerialOut(unsigned long data){
    unsigned int i;                     // rbgJE^
    unsigned long mask;                 // rbg}XN
    
    mask = 0x8000;                      // rbg}XNZbg
    ddsFSYN = 0;                        // FSYNC Low Jn
    for(i=0; i<16; i++){                // 16rbgJԂ
        if(data & mask)                 // f[^rbgo
            ddsSDAT = 1;                // SDAT1̏ꍇ
        else
            ddsSDAT = 0;                // SDAT0̏ꍇ
        ddsSCLK = 0;                    // SCK Low
        ddsSCLK = 1;                    // SCK High@NbNo
        mask = mask >> 1;               // rbg}XNVtg
    }
    ddsFSYN = 1;                        // FSYNC HighI
}
